local name, ns = ...
local debug = ns.debug

local Addon = _G[name]
local tq = LibStub("LibTalentQuery-1.0")

local talentSpecs = {}
local talentSpecNames = {}
local talentSpecIcons = {}
local function updatetalent(event, name, realm)
	if InCombatLockdown() then
		-- do not do anything when in combat
		return
	end
	local name = name .. (realm or "")
	local data = talentSpecs[name] or {[1] = {}, [2] = {}, [3] = {},}
	local specName = { NONE, 0 }
	for i = 1, 3 do
		-- get the active talentgroup to avoid wrong talentscans
		local name, icon, points = GetTalentTabInfo(i, name ~= UnitName("player"),
				false, GetActiveTalentGroup(true))
		data[i][1] = name
		data[i][2] = points
		data[i][3] = icon
		if points > specName[2] then
			specName[1] = name
			specName[2] = points
			specName[3] = icon
		elseif points == specName[2] then
			specName[1] = "Hybrid"
		end
	end
	talentSpecs[name] = data
	talentSpecNames[name] = specName[1]
	talentSpecIcons[name] = specName[3]
end
tq.RegisterCallback(Addon, "TalentQuery_Ready", updatetalent)


local MIN_TIME_UNTIL_RESCAN = 10
local lastscan = {}
local function TalentSpec(unit)
	if not UnitIsPlayer(unit) then
		return
	end
	local name = UnitName(unit)
	if not name then return end
	if not lastscan[name] or (GetTime() - lastscan[name]) > MIN_TIME_UNTIL_RESCAN then
		tq:Query(unit)
		lastscan[name] = GetTime()
	end
	local spec = talentSpecs[name]
	if spec then
		return ("%d/%d/%d"):format(spec[1][2], spec[2][2], spec[3][2])
	end
end

Addon:AddScriptEnvFunction("TalentSpec", TalentSpec)

local function TalentSpecName(unit)
	if not UnitIsPlayer(unit) then
		return
	end
	local name = UnitName(unit)
	if not name then return end
	if not lastscan[name] or (GetTime() - lastscan[name]) > MIN_TIME_UNTIL_RESCAN then
		tq:Query(unit)
		lastscan[name] = GetTime()
	end
	return talentSpecNames[name]
end
Addon:AddScriptEnvFunction("TalentSpecName", TalentSpecName)

local function TalentSpecIcon(unit)
	if not UnitIsPlayer(unit) then
		return
	end
	local name = UnitName(unit)
	if not name then return end
	if not lastscan[name] or (GetTime() - lastscan[name]) > MIN_TIME_UNTIL_RESCAN then
		tq:Query(unit)
		lastscan[name] = GetTime()
	end
	return talentSpecIcons[name]
end
Addon:AddScriptEnvFunction("TalentSpecIcon", TalentSpecIcon)
